

    /* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\
    *                                                                 *
    *   mfcalc 2.0, Extended GNU Bison Example #3                     *
    *   Copyright  2005 Sebastian Pipping <webmaster@hartwork.org>   *
    *                                                                 *
    *   --> http://www.hartwork.org                                   *
    *                                                                 *
    *                                                                 *
    *   This source code is released under GPL.                       *
    *   See GPL.txt for details.                         2005-02-23   *
    *                                                                 *
    \* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */



#ifndef __CALC_H__
#define __CALC_H__


typedef void * func_t;


/* Data type for links in the chain of symbols. */
struct symrec
{
	char *name; /* name of symbol */
	int type; /* type of symbol: either CONST, VAR or FNCT */
	union
	{
		double var; /* value of a CONST/VAR */
		func_t fnctptr; /* value of a FNCT */
	} value;
	struct symrec *next; /* link field */
};

typedef struct symrec symrec;


/* The symbol table: a chain of 'struct symrec'. */
extern symrec *sym_table;
symrec *putsym (char const *, int);
symrec *getsym (char const *);


struct argrec
{
	double val;
	struct argrec *next;
};

typedef struct argrec argrec;

argrec *live (double);
argrec *grow (argrec *, double);
void die (argrec *);


/* Function type. */
// typedef double (*func_t) (double);
typedef double (* func_zero) ();
typedef double (* func_one) (double);
typedef double (* func_two) (double, double);
typedef double (* func_three) (double, double, double);
typedef double (* func_many) (argrec *);


#endif // __CALC_H__